#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_zJIK0x60x60TN1x3x2_a1_b0
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=60, KB=60, 
 * lda=60, ldb=60, ldc=0, mu=1, nu=3, ku=2, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   #define Mb M
   const double *stM = A + (60*(Mb));
   const double *stN = B + 3600;
   const double *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*1*3)/(M*N*sizeof(double));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 2
   const int incAm = 0, incAn = -(60*(Mb));
   #define incBk 2
   const int incBm = -60, incBn = 180;
   #define incCm 2
   const int incCn = (((ldc) << 2)+((ldc) << 1)) - (((Mb) << 1));
   double *pC0=C, *pC1=pC0+(((ldc) << 1)), *pC2=pC1+(((ldc) << 1));
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0;
   register double rB0, rB1, rB2;
   register double rC0_0, rC0_1, rC0_2;
   do /* N-loop */
   {
      do /* M-loop */
      {
         ATL_pfl1R(pfA);
         pfA += incPFA;
         ATL_pfl1W(pC0);
         ATL_pfl1W(pC1);
         ATL_pfl1W(pC2);
/*
 *       Peel 1st iter to assign C regs
 */
         rA0 = *pA0;
         rB0 = *pB0;
         rC0_0 = rA0 * rB0;
         rB1 = pB0[60];
         rB2 = pB0[120];
         rC0_1 = rA0 * rB1;
         rC0_2 = rA0 * rB2;
         rA0 = pA0[1];
         rB0 = pB0[1];
         rC0_0 += rA0 * rB0;
         rB1 = pB0[61];
         rB2 = pB0[121];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         pA0 += incAk;
         pB0 += incBk;
/*
 *       Unpeeled K iterations
 */
         for (k=58; k; k -= 2) /* easy loop to unroll */
         {
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            rB1 = pB0[60];
            rB2 = pB0[120];
            rC0_1 += rA0 * rB1;
            rC0_2 += rA0 * rB2;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += rA0 * rB0;
            rB1 = pB0[61];
            rB2 = pB0[121];
            rC0_1 += rA0 * rB1;
            rC0_2 += rA0 * rB2;
            pA0 += incAk;
            pB0 += incBk;
         }
         *pC0 = rC0_0;
         *pC1 = rC0_1;
         *pC2 = rC0_2;
         pC0 += incCm;
         pC1 += incCm;
         pC2 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pC1 += incCn;
      pC2 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_zJIK0x60x60TN60x60x0_a1_b0
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=60, KB=60, 
 * lda=60, ldb=60, ldc=0, mu=3, nu=3, ku=2, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const int Mb = (M/3)*3;
   const double *ca=A, *cb=B;
   double *cc=C;
   const double *stM = A + (60*(Mb));
   const double *stN = B + 3600;
   const double *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*3*3)/(M*N*sizeof(double));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 2
   const int incAm = 120, incAn = -(60*(Mb));
   #define incBk 2
   const int incBm = -60, incBn = 180;
   #define incCm 6
   const int incCn = (((ldc) << 2)+((ldc) << 1)) - (((Mb) << 1));
   double *pC0=C, *pC1=pC0+(((ldc) << 1)), *pC2=pC1+(((ldc) << 1));
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0, rA1, rA2;
   register double rB0, rB1, rB2;
   register double rC0_0, rC1_0, rC2_0, rC0_1, rC1_1, rC2_1, rC0_2, rC1_2, rC2_2;
   if (pA0 != stM)
   {
      do /* N-loop */
      {
         do /* M-loop */
         {
            ATL_pfl1R(pfA);
            pfA += incPFA;
            ATL_pfl1W(pC0);
            ATL_pfl1W(pC1);
            ATL_pfl1W(pC2);
/*
 *          Peel 1st iter to assign C regs
 */
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 = rA0 * rB0;
            rA1 = pA0[60];
            rA2 = pA0[120];
            rC1_0 = rA1 * rB0;
            rB1 = pB0[60];
            rB2 = pB0[120];
            rC2_0 = rA2 * rB0;
            rC0_1 = rA0 * rB1;
            rC1_1 = rA1 * rB1;
            rC2_1 = rA2 * rB1;
            rC0_2 = rA0 * rB2;
            rC1_2 = rA1 * rB2;
            rC2_2 = rA2 * rB2;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += rA0 * rB0;
            rA1 = pA0[61];
            rA2 = pA0[121];
            rC1_0 += rA1 * rB0;
            rB1 = pB0[61];
            rB2 = pB0[121];
            rC2_0 += rA2 * rB0;
            rC0_1 += rA0 * rB1;
            rC1_1 += rA1 * rB1;
            rC2_1 += rA2 * rB1;
            rC0_2 += rA0 * rB2;
            rC1_2 += rA1 * rB2;
            rC2_2 += rA2 * rB2;
            pA0 += incAk;
            pB0 += incBk;
/*
 *          Unpeeled K iterations
 */
            for (k=58; k; k -= 2) /* easy loop to unroll */
            {
               rA0 = *pA0;
               rB0 = *pB0;
               rC0_0 += rA0 * rB0;
               rA1 = pA0[60];
               rA2 = pA0[120];
               rC1_0 += rA1 * rB0;
               rB1 = pB0[60];
               rB2 = pB0[120];
               rC2_0 += rA2 * rB0;
               rC0_1 += rA0 * rB1;
               rC1_1 += rA1 * rB1;
               rC2_1 += rA2 * rB1;
               rC0_2 += rA0 * rB2;
               rC1_2 += rA1 * rB2;
               rC2_2 += rA2 * rB2;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rC0_0 += rA0 * rB0;
               rA1 = pA0[61];
               rA2 = pA0[121];
               rC1_0 += rA1 * rB0;
               rB1 = pB0[61];
               rB2 = pB0[121];
               rC2_0 += rA2 * rB0;
               rC0_1 += rA0 * rB1;
               rC1_1 += rA1 * rB1;
               rC2_1 += rA2 * rB1;
               rC0_2 += rA0 * rB2;
               rC1_2 += rA1 * rB2;
               rC2_2 += rA2 * rB2;
               pA0 += incAk;
               pB0 += incBk;
            }
            *pC0 = rC0_0;
            pC0[2] = rC1_0;
            pC0[4] = rC2_0;
            *pC1 = rC0_1;
            pC1[2] = rC1_1;
            pC1[4] = rC2_1;
            *pC2 = rC0_2;
            pC2[2] = rC1_2;
            pC2[4] = rC2_2;
            pC0 += incCm;
            pC1 += incCm;
            pC2 += incCm;
            pA0 += incAm;
            pB0 += incBm;
         }
         while(pA0 != stM);
         pC0 += incCn;
         pC1 += incCn;
         pC2 += incCn;
         pA0 += incAn;
         pB0 += incBn;
      }
      while(pB0 != stN);
   }
   if (k=M-Mb)
      ATL_zJIK0x60x60TN1x3x2_a1_b0(k, 60, 60, alpha, ca + (60*(Mb)), lda, cb, ldb, beta, cc + (((Mb) << 1)), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
#ifdef ATL_UCLEANM
#define ATL_zpMBmm_b0 ATL_zgpMBmm_b0
#endif

void ATL_zJIK0x60x60TN60x60x0_a1_b0(const int M, const int N, const int K, const double alpha, const double *A, const int lda, const double *B, const int ldb, const double beta, double *C, const int ldc);
void ATL_zJIK0x60x60TN60x60x0_a1_bX(const int M, const int N, const int K, const double alpha, const double *A, const int lda, const double *B, const int ldb, const double beta, double *C, const int ldc);
void ATL_zJIK0x60x60TN60x60x0_a1_b1(const int M, const int N, const int K, const double alpha, const double *A, const int lda, const double *B, const int ldb, const double beta, double *C, const int ldc);

void ATL_zpMBmm_b0(const int M, const int N, const int K, const double alpha, const double *A, const int lda, const double *B, const int ldb, const double beta, double *C, const int ldc)
{
   ATL_zJIK0x60x60TN60x60x0_a1_b0(M, N, K, alpha, A, lda, B, ldb, -beta, C, ldc);
   ATL_zJIK0x60x60TN60x60x0_a1_b0(M, N, K, alpha, A, lda, B+N*ldb, ldb, beta, C+1, ldc);
   ATL_zJIK0x60x60TN60x60x0_a1_bX(M, N, K, alpha, A+M*lda, lda, B+N*ldb, ldb, -1.0, C, ldc);
   ATL_zJIK0x60x60TN60x60x0_a1_b1(M, N, K, alpha, A+M*lda, lda, B, ldb, 1.0, C+1, ldc);
}
